
Application: gvSIG desktop - gvSIG bugs #4538
Falla al exportar la tabla "country" de PostgreSQL a SpatiaLite.
07/15/2017 12:43 PM - Joaquín  del Cerro Murciano
Description

    -  Creo una vista en 4326
    -  Cargo el shape country
    -  La exporto a PostgreSQL
    -  Cargo la capa country de PostgreSQL.
    -  La selecciono y exporto a SpatialLite.

Falla. 
En la consola aparece:

 WARN 716648 [Thread-23] (DefaultJExporttoServicePanel.java:286) - Problems exporting the data (layer="public"."country").
org.gvsig.exportto.ExporttoServiceException: An error has been produced exporting a store
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.export(ExporrtoJDBCService.java:343)
        at org.gvsig.exportto.swing.impl.DefaultJExporttoServicePanel$Export.run(DefaultJExporttoServicePanel.java:284)
Caused by: java.lang.RuntimeException: Can't perform operation 'CreateTableOperation'.
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform_operation(AbstractConnectionOperation.java:77)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform(AbstractConnectionOperation.java:41)
        at org.gvsig.fmap.dal.store.jdbc2.spi.JDBCServerExplorerBase.add(JDBCServerExplorerBase.java:354)
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.createTable(ExporrtoJDBCService.java:149)
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.export(ExporrtoJDBCService.java:197)
        ... 1 more
Caused by: org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLExc
va:77)
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform(AbstractConnectionOperation.java:41)
        at org.gvsig.fmap.dal.store.jdbc2.spi.JDBCServerExplorerBase.add(JDBCServerExplorerBase.java:354)
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.createTable(ExporrtoJDBCService.java:149)
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.export(ExporrtoJDBCService.java:197)
        ... 1 more
Caused by: org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLException: An JDBC driver exception was throw
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.CreateTableOperation.performCreateTable(CreateTableOperation.java:109)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.CreateTableOperation.perform(CreateTableOperation.java:53)
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform_operation(AbstractConnectionOperation.java:70)
        ... 5 more
Caused by: java.sql.SQLException: [SQLITE_ERROR] SQL error or missing database (unknown database "public")
        at org.spatialite.core.DB.newSQLException(DB.java:892)
        at org.spatialite.core.DB.newSQLException(DB.java:903)
        at org.spatialite.core.DB.throwex(DB.java:870)
        at org.spatialite.core.NativeDB.prepare(Native Method)
        at org.spatialite.core.DB.prepare(DB.java:213)
        at org.spatialite.jdbc3.JDBC3Statement.execute(JDBC3Statement.java:60)
        at org.gvsig.fmap.dal.store.jdbc2.JDBCUtils.execute(JDBCUtils.java:33)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.CreateTableOperation.performCreateTable(CreateTableOperation.java:106)
        ... 7 more


va:70)
        ... 5 more
Caused by: java.sql.SQLException: [SQLITE_ERROR] SQL error or missing database (unknown database "public")
        at org.spatialite.core.DB.newSQLException(DB.java:892)
        at org.spatialite.core.DB.newSQLException(DB.java:903)
        at org.spatialite.core.DB.throwex(DB.java:870)
        at org.spatialite.core.NativeDB.prepare(Native Method)
        at org.spatialite.core.DB.prepare(DB.java:213)
        at org.spatialite.jdbc3.JDBC3Statement.execute(JDBC3Statement.java:60)
        at org.gvsig.fmap.dal.store.jdbc2.JDBCUtils.execute(JDBCUtils.java:33)
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.CreateTableOperation.performCreateTable(CreateTableOperation.java:106)
        ... 7 more

Repitiendo el proceso he obserbado que en el paso Nombre de tabla me ofrece el nombre "public"."country" cuando deberia ser 
country.
Corrigiendolo el nombre de tabla y continuando falla mostrando el siguiente error en la consola:

WARN 988087 [Thread-27] (DefaultJExporttoServicePanel.java:286) - Problems exporting the data (layer="public"."country").
org.gvsig.exportto.ExporttoServiceException: An error has been produced exporting a store
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.export(ExporrtoJDBCService.java:343)
        at org.gvsig.exportto.swing.impl.DefaultJExporttoServicePanel$Export.run(DefaultJExporttoServicePanel.java:284)
Caused by: java.lang.RuntimeException: Can't perform operation 'CreateTableOperation'.
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform_operation(AbstractConnectionOperation.java:77)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform(AbstractConnectionOperation.java:41)
        at org.gvsig.fmap.dal.store.jdbc2.spi.JDBCServerExplorerBase.add(JDBCServerExplorerBase.java:354)
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.createTable(ExporrtoJDBCService.java:149)
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.export(ExporrtoJDBCService.java:197)
        ... 1 more
Caused by: org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLEx
va:77)
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform(AbstractConnectionOperation.java:41)
        at org.gvsig.fmap.dal.store.jdbc2.spi.JDBCServerExplorerBase.add(JDBCServerExplorerBase.java:354)
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.createTable(ExporrtoJDBCService.java:149)
        at org.gvsig.exportto.swing.prov.jdbc.ExporrtoJDBCService.export(ExporrtoJDBCService.java:197)
        ... 1 more
Caused by: org.gvsig.fmap.dal.store.jdbc.exception.JDBCSQLException: An JDBC driver exception was throw
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.CreateTableOperation.performCreateTable(CreateTableOperation.java:109)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.CreateTableOperation.perform(CreateTableOperation.java:53)
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform_operation(AbstractConnectionOperation.java:70)
        ... 5 more
Caused by: java.sql.SQLException: [SQLITE_ERROR] SQL error or missing database (table "country" has more than one primary key)
        at org.spatialite.core.DB.newSQLException(DB.java:892)
        at org.spatialite.core.DB.newSQLException(DB.java:903)
        at org.spatialite.core.DB.throwex(DB.java:870)
        at org.spatialite.core.NativeDB.prepare(Native Method)
        at org.spatialite.core.DB.prepare(DB.java:213)
        at org.spatialite.jdbc3.JDBC3Statement.execute(JDBC3Statement.java:60)
        at org.gvsig.fmap.dal.store.jdbc2.JDBCUtils.execute(JDBCUtils.java:33)
        at org.gvsig.fmap.dal.store.jdbc2.spi.operations.CreateTableOperation.performCreateTable(CreateTableOperation.java:106)
        ... 7 more


va:70)
        ... 5 more
Caused by: java.sql.SQLException: [SQLITE_ERROR] SQL error or missing database (table "country" has more than one
primary key)
        at org.spatialite.core.DB.newSQLException(DB.java:892)
        at org.spatialite.core.DB.newSQLException(DB.java:903)
        at org.spatialite.core.DB.throwex(DB.java:870)
        at org.spatialite.core.NativeDB.prepare(Native Method)
        at org.spatialite.core.DB.prepare(DB.java:213)
        at org.spatialite.jdbc3.JDBC3Statement.execute(JDBC3Statement.java:60)
        at org.gvsig.fmap.dal.store.jdbc2.JDBCUtils.execute(JDBCUtils.java:33)
        at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.CreateTableOperation.performCreateTable(CreateTableOperation.java:106)
        ... 7 more

Associated revisions
Revision 43397 - 07/27/2017 07:09 PM - Joaquín  del Cerro Murciano

refs #4538, corregido el metodo getName del store de jdbc y comprobado en SelectPkPanel que no marque por defecto crear clave primaria si la capa
de origen ya tiene una clave primaria.

History
#1 - 07/27/2017 07:12 PM - Joaquín  del Cerro Murciano
- Target version changed from 2.4.0-2850-final (rev. org.gvsig.desktop-2.0.220) to 2.4.0-2830 (rev. org.gvsig.desktop-2.0.196)
- Assignee set to Joaquín  del Cerro Murciano
- Status changed from New to Fixed

#2 - 08/08/2017 10:24 AM - Álvaro Anguix
- Status changed from Fixed to Closed
